#include "Circle.h"


Circle::Circle(EditPanel *editPanel, Coord center, double r, wxString name, wxColor color):
          GeomObj(editPanel, center, name, color)
{
  radius = r;
}

double Circle::GetRadius()
{
    return radius;
}

void Circle::Paint(wxDC& dc)
{
    if (!visibility)
        return;
    int tmpx = pos.ToScreenX(editPanel);
    int tmpy = pos.ToScreenY(editPanel);
    dc.SetBrush(*wxTRANSPARENT_BRUSH);
    dc.SetPen(wxPen(color,width));
    dc.DrawCircle(wxCoord(tmpx), wxCoord(tmpy), radius / editPanel->zoom);
    if (label)
    {
        dc.SetTextForeground(color);
        Coord pos2 = Coord(pos.x + radius, pos.y);
        dc.DrawText(name, pos2.ToScreenX(editPanel), pos2.ToScreenY(editPanel));
    }
}

void Circle::Paint(wxDC& dc, wxColor newColor)
{
    if (!visibility)
        return;
    int tmpx = pos.ToScreenX(editPanel);
    int tmpy = pos.ToScreenY(editPanel);
    dc.SetBrush(*wxTRANSPARENT_BRUSH);
    dc.SetPen(wxPen(newColor,width));
    dc.DrawCircle(wxCoord(tmpx), wxCoord(tmpy), radius / editPanel->zoom);
    if (label)
    {
        dc.SetTextForeground(color);
        Coord pos2 = Coord(pos.x + radius, pos.y);
        dc.DrawText(name, pos2.ToScreenX(editPanel), pos2.ToScreenY(editPanel));
    }
}


objectType Circle::GetType()
{
    return oCIRCLE;
}

wxString Circle::GetName()
{
    return name;
}

wxString Circle::GetText()
{
    wxString R;
    R << radius;

    wxString text = name + wxS("; ") + name + wxS(" je kružnice, r = ") + R;
    return text;
}

