#ifndef GEOMOBJ_H
#define GEOMOBJ_H

#include <wx/wx.h>
#include "EditPanel.h"

enum objectType {oPOINT, oLINE, oCIRCLE, oELLIPSE, oPARABOLA, oHYPERBOLE};


class GeomObj
{
  protected:
    Coord pos;
    wxColor color;
    wxString name;
    int width;
    bool label;
    bool visibility;
    bool change;

  public:
    GeomObj(EditPanel *editPanel, Coord pos, wxString name, wxColor color = wxColor(0,0,0));

    virtual void Paint(wxDC& dc)=0;
    virtual void Paint(wxDC& dc, wxColor newColor)=0;
    virtual objectType GetType()=0;
    virtual wxString GetName()=0;
    virtual Coord GetPos2();
    virtual void ChangePos2(Coord coord);
    virtual double GetRadius();
    virtual double GetA();
    virtual double GetB();
    virtual double GetP();
    virtual double GetAlfa();
    virtual void ChangeWidth(int newWidth);
    virtual wxString GetText()=0;
    virtual Coord GetPos();

    bool GetChange();
    void SetChange(bool change);
    void SetVisibility(bool viz);
    void SetLabel(bool newLabel);
    bool GetVisibility();
    bool GetLabel();
    int GetWidth();
    wxColor GetColor();
    void Delete();
    void SetColor(wxColor);

    void ChangePos(Coord coord);
    EditPanel *editPanel;
};

#endif
