#include "Line.h"


Line::Line(EditPanel *editPanel, Coord p1, Coord p2, wxString name, wxColor color):
        GeomObj(editPanel, p1, name, color)
{
  this->pos2 = p2;
  typLine = 0;
}

Line::Line(EditPanel *editPanel, Coord p, GeomObj *line, wxString relation, wxString name, wxColor color):
        GeomObj(editPanel, p, name, color)
{
    double ux = line->GetPos().x - line->GetPos2().x; //naucit coordy se scitat samy
    double uy = line->GetPos().y - line->GetPos2().y;

    //kolmy prumet bodu, kterym chceme vest novou primku
    double t = (-uy*line->GetPos().x + p.x*uy + ux*line->GetPos().y - p.y*ux) / (ux*ux + uy*uy);

    if (relation == wxS("Per"))
    {
        //vector nove primky kolme je: (-uy, ux)
        pos2.x = p.x - t*uy;
        pos2.y = p.y + t*ux;
        typLine = 1;
        kolmice = line->GetName();
    }
    else if (relation == wxS("Par"))
    {
        //vector nove primky rovnobezne je: (ux, uy)
        double tmpX = p.x - t*uy;
        double tmpY = p.y + t*ux;

        pos2.x = (line->GetPos().x + (p.x - tmpX));
        pos2.y = (line->GetPos().y + (p.y - tmpY));
        pos.x = (line->GetPos2().x + (p.x - tmpX));
        pos.y = (line->GetPos2().y + (p.y - tmpY));
        typLine = 2;
        rovnobezka = line->GetName();
    }
}

void Line::Paint(wxDC& dc)
{
    if (!visibility)
        return;
    int tmpx = pos.ToScreenX(editPanel);
    int tmpy = pos.ToScreenY(editPanel);
    int tmpxx = pos2.ToScreenX(editPanel);
    int tmpyy = pos2.ToScreenY(editPanel);
    dc.SetPen(wxPen(color,width));
    dc.DrawLine(wxCoord(tmpx), wxCoord(tmpy), wxCoord(tmpxx), wxCoord(tmpyy));
    if (label)
    {
        dc.SetTextForeground(color);
        dc.DrawText(name, pos.ToScreenX(editPanel), pos.ToScreenY(editPanel));
    }
}

void Line::Paint(wxDC& dc, wxColor newColor)
{
    if (!visibility)
        return;
    int tmpx = pos.ToScreenX(editPanel);
    int tmpy = pos.ToScreenY(editPanel);
    int tmpxx = pos2.ToScreenX(editPanel);
    int tmpyy = pos2.ToScreenY(editPanel);
    dc.SetPen(wxPen(newColor,width));
    dc.DrawLine(wxCoord(tmpx), wxCoord(tmpy), wxCoord(tmpxx), wxCoord(tmpyy));
    if (label)
    {
        dc.SetTextForeground(color);
        dc.DrawText(name, pos.ToScreenX(editPanel), pos.ToScreenY(editPanel));
    }
}

objectType Line::GetType()
{
    return oLINE;
}

Coord Line::GetPos2()
{
    return pos2;
}

wxString Line::GetName()
{
    return name;
}

void Line::ChangePos2(Coord coord)
{
    pos2 = coord;
}

wxString Line::GetText()
{
    wxString text;

    if (typLine == 0)
        text = name + wxS("; ") + name + wxS(" je přímka");
    if (typLine == 1)
        text = name + wxS("; ") + name + wxS(" je kolmá na ") + kolmice;
    if (typLine == 2)
        text = name + wxS("; ") + name + wxS(" je rovnoběžná s ") + rovnobezka;

    return text;
}
