#include "Point.h"


Point::Point(EditPanel *editPanel, Coord pos, wxString name, wxColor color):
        GeomObj(editPanel, pos, name, color)
{}

void Point::Paint(wxDC& dc)
{
    if (!visibility)
        return;
    int tmpx = pos.ToScreenX(editPanel);
    int tmpy = pos.ToScreenY(editPanel);
    //dc.SetPen(wxPen(color,width));

    dc.SetBrush(*wxTRANSPARENT_BRUSH);
    dc.SetPen(wxPen(color,width));
    dc.DrawCircle(wxCoord(tmpx), wxCoord(tmpy), 1);

    if (width == 1)
    {
        dc.DrawPoint(wxPoint(tmpx,tmpy));
    }
//    dc.DrawPoint(wxPoint(tmpx,tmpy));
//    dc.DrawPoint(wxPoint(tmpx+1,tmpy));
//    dc.DrawPoint(wxPoint(tmpx-1,tmpy));
//    dc.DrawPoint(wxPoint(tmpx,tmpy+1));
//    dc.DrawPoint(wxPoint(tmpx,tmpy-1));
    if (label)
    {
        dc.SetTextForeground(color);
        dc.DrawText(name, pos.ToScreenX(editPanel), pos.ToScreenY(editPanel)-20);
    }
}

void Point::Paint(wxDC& dc, wxColor newColor)
{
    if (!visibility)
        return;
    int tmpx = pos.ToScreenX(editPanel);
    int tmpy = pos.ToScreenY(editPanel);

    dc.SetBrush(*wxTRANSPARENT_BRUSH);
    dc.SetPen(wxPen(newColor,width));
    dc.DrawCircle(wxCoord(tmpx), wxCoord(tmpy), 1);

    if (width == 1)
    {
        dc.SetPen(wxPen(newColor,width+1));
        dc.DrawPoint(wxPoint(tmpx,tmpy));
    }

//    dc.SetPen(wxPen(newColor,width));
//    dc.DrawPoint(wxPoint(tmpx,tmpy));
//    dc.DrawPoint(wxPoint(tmpx+1,tmpy));
//    dc.DrawPoint(wxPoint(tmpx-1,tmpy));
//    dc.DrawPoint(wxPoint(tmpx,tmpy+1));
//    dc.DrawPoint(wxPoint(tmpx,tmpy-1));
    if (label)
    {
        dc.SetTextForeground(color);
        dc.DrawText(name, pos.ToScreenX(editPanel), pos.ToScreenY(editPanel)-20);
    }
}

objectType Point::GetType()
{
    return oPOINT;
}

wxString Point::GetName()
{
    return name;
}

wxString Point::GetText()
{
    wxString text = name + wxS("; ") + name + wxS(" je bod");
    return text;
}
