#include "SmallClasses.h"
#include "EditPanel.h"
#include "GeomObj.h"
#include <string>

#define A 65
#define a 97
#define Z 90
#define z 122


Coord::Coord()
{
    this->x = 0;
    this->y = 0;
}

Coord::Coord(double x, double y)
{
    this->x = x;
    this->y = y;
}

Coord::Coord(EditPanel *panel, int x, int y)
{
     this->x = (x - panel->offsetx) * panel->zoom;
     this->y = (y - panel->offsety) * panel->zoom;
}

int Coord::ToScreenX(EditPanel *panel)
{
    return (x / panel->zoom) + panel->offsetx;
}

int Coord::ToScreenY(EditPanel *panel)
{
    return (y / panel->zoom) + panel->offsety;
}

double Coord::DistTo(Coord c)
{
    return sqrt((x - c.x)*(x - c.x) + (y - c.y)*(y - c.y));
}

bool Coord::operator==(Coord pos)
{
    return (x == pos.x && y == pos.y);
}

bool Coord::operator!=(Coord pos)
{
    return (x != pos.x || y != pos.y);
}

Coord Coord::operator+(Coord pos)
{
    return Coord(x + pos.x, y + pos.y);
}

Coord Coord::operator-(Coord pos)
{
    return Coord(x - pos.x, y - pos.y);
}


//ascii tabulka
//a - 97, ... z - 122
//A - 65, ... Z - 90

Name::Name(EditPanel *editP)
{
    edit = editP;
//    point = A;
//    constPoint = 0;
//    bod se pohybuje od 65 - 90
//    usecka a kruznice se doplnuji / tj maji stejne konstanty /se pohybuje od 97 - 122
//    other = a;
//    constOther = 0;
}

wxString Name::GetNamePoint()
{
    point = 'A';
    constPoint = 0;
    bool ok = false;
    wxString tmp, tmp2;
    while (!ok)
    {
        ok = true;
        if (constPoint == 0)
        {
            tmp = tmp.FromAscii(point);
            ++point;
            if (point > Z)
            {
                point = A;
                ++constPoint;
            }
        }
        else
        {
            tmp = tmp.FromAscii(point);
            tmp2 = tmp2.Format(wxT("%i"), constPoint);
            ++point;
            if (point > Z)
            {
                point = A;
                ++constPoint;
            }
        }
        if (!edit->objList.empty())
        {
            ObjList::iterator i;
            for (i = edit->objList.begin(); i != edit->objList.end(); ++i)
            {
                if ((*i)->GetType() == oPOINT)
                {
                    if ((*i)->GetName() == (tmp + tmp2))
                    {
                        ok = false;
                        break;
                    }
                }
            }
        }
    }

    return tmp+tmp2;
}

wxString Name::GetNameOther()
{
    other = 'a';
    constOther = 0;
    bool ok = false;
    wxString tmp, tmp2;
    while (!ok)
    {
        ok = true;
        if (constOther == 0)
        {
            tmp = tmp.FromAscii(other);
            ++other;
            if (other > z)
            {
                other = a;
                ++constOther;
            }
        }
        else
        {
            tmp = tmp.FromAscii(other);
            tmp2 = tmp2.Format(wxT("%i"), constOther);
            ++other;
            if (other > z)
            {
                other = a;
                ++constOther;
            }
        }
        if (!edit->objList.empty())
        {
            ObjList::iterator i;
            for (i = edit->objList.begin(); i != edit->objList.end(); ++i)
            {
                if ((*i)->GetType() != oPOINT)
                {
                    if ((*i)->GetName() == (tmp + tmp2))
                    {
                        ok = false;
                        break;
                    }
                }
            }
        }
    }
    return tmp+tmp2;
}


Dialog2::Dialog2( wxWindow* parent, wxWindowID id, const wxString& title, const wxPoint& pos, const wxSize& size, long style ) : wxDialog( parent, id, title, pos, size, style )
{
	this->SetSizeHints( wxDefaultSize, wxDefaultSize );

	wxBoxSizer* bSizer12 = new wxBoxSizer( wxVERTICAL );

	wxBoxSizer* bSizer13 = new wxBoxSizer( wxHORIZONTAL );

	m_staticText34 = new wxStaticText( this, wxID_ANY, wxT("Šířka mřížky"), wxDefaultPosition, wxDefaultSize, 0 );
	m_staticText34->Wrap( -1 );
	bSizer13->Add( m_staticText34, 0, wxALL, 5 );

	m_spinCtrl4 = new wxSpinCtrl( this, wxID_ANY, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxSP_ARROW_KEYS, 10, 100, 10 );
	bSizer13->Add( m_spinCtrl4, 0, wxALL, 5 );

	bSizer12->Add( bSizer13, 1, wxEXPAND, 5 );

	wxString m_radioBox1Choices[] = { wxT("body"), wxT("přímky") };
	int m_radioBox1NChoices = sizeof( m_radioBox1Choices ) / sizeof( wxString );
	m_radioBox1 = new wxRadioBox( this,
                                  wxID_ANY,
                                  wxT("Styl mřížky"),
                                  wxDefaultPosition,
                                  wxDefaultSize,
                                  m_radioBox1NChoices,
                                  m_radioBox1Choices,
                                  1,
                                  wxRA_SPECIFY_COLS );
	m_radioBox1->SetSelection( 0 );
	bSizer12->Add( m_radioBox1, 0, wxALL|wxEXPAND, 5 );

	m_sdbSizer2 = new wxStdDialogButtonSizer();
	m_sdbSizer2OK = new wxButton( this, wxID_OK );
	m_sdbSizer2->AddButton( m_sdbSizer2OK );
	m_sdbSizer2Cancel = new wxButton( this, wxID_CANCEL );
	m_sdbSizer2->AddButton( m_sdbSizer2Cancel );
	m_sdbSizer2->Realize();
	bSizer12->Add( m_sdbSizer2, 1, wxEXPAND, 5 );

	this->SetSizer( bSizer12 );
	this->Layout();
	bSizer12->Fit( this );
}

Dialog2::~Dialog2()
{
}

